bl_info = {
    "name": "Cpp Test",
    "author": "akaneyu",
    "version": (1, 0, 0),
    "blender": (2, 82, 0),
    "location": "Image",
    "warning": "",
    "description": "",
    "wiki_url": "",
    "tracker_url": "",
    "category": "Paint"}

if "bpy" in locals():
    import importlib
    importlib.reload(cpp_test)
    importlib.reload(utils)

import os
import glob
import bpy
from . import cpp_test

classes = [
    cpp_test.CPPTEST_OT_GenerateImage,
    cpp_test.CPPTEST_PT_Panel
]

def rename_dylib():
    current_dir = os.path.dirname(os.path.realpath(__file__))

    for file_name in glob.glob(os.path.join(current_dir, "*.pyd.000")):
        dest_file_name = file_name[:file_name.rfind('.')]
        if os.path.isfile(dest_file_name):
            os.remove(dest_file_name)   # stop here if the dylib is in use (PermissionError)

        os.rename(file_name, dest_file_name)    # should not fail here

def register():
    if os.name == 'nt':
        try:
            rename_dylib()
        except Exception as e:
            raise Exception("\n\nRequires restarting Blender.")

    for cls in classes:
        bpy.utils.register_class(cls)

def unregister():
    for cls in classes:
        bpy.utils.unregister_class(cls)

if __name__ == "__main__":
    register()
