import sys
import os
import bpy
import numpy as np
from . import utils

class Session:
    def __init__(self):
        pass

def get_session():
    global session

    return session

class CPPTEST_OT_GenerateImage(bpy.types.Operator):
    """Generate a image"""
    bl_idname = "cpp_test.generate_image"
    bl_label = "Generate Image"
    bl_options = {'REGISTER', 'UNDO'}

    def execute(self, context):
        global session

        wm = context.window_manager

        from . cpp_test_processor import FloatBuffer, Processor

        processor = Processor()

        img = bpy.data.images.new('cpp_test', 1024, 1024, alpha=True)

        context.tool_settings.image_paint.canvas = img
        context.tool_settings.image_paint.mode = 'IMAGE'

        img_width, img_height = img.size

        pixels_buff = FloatBuffer(img_width * img_height * 4)

        processor.set_image_size(img_width, img_height)
        processor.set_image_pixels(pixels_buff)

        pixels = np.asarray(pixels_buff)
        utils.read_pixels_from_image(img, pixels)

        processor.process()

        utils.write_pixels_to_image(img, pixels)

        return {'FINISHED'}

class CPPTEST_PT_Panel(bpy.types.Panel):
    bl_label = "Cpp Test"
    bl_space_type = "IMAGE_EDITOR"
    bl_region_type = "UI"
    bl_category = "Cpp Test"

    @classmethod
    def poll(cls, context):
        return True

    def draw(self, context):
        layout = self.layout

        row = layout.row()
        op = row.operator(CPPTEST_OT_GenerateImage.bl_idname, text='Generate Image')

session = Session()
